MAX = 10**9

N, M, K = [ int(x) for x in input().split() ]
K = max(1,K) # if we can output any such array, we output the smallest one

pocet = [ N//M for m in range(M) ]
rozdaj = N - M*(N//M)

# there are choose(M,rozdaj) arrays with the optimal number of inversions
# out of these, there are first choose(M-1,rozdaj) arrays that *don't* have an extra M,
# and then choose(M-1,rozdaj-1) arrays that *do* have an extra M

def choose(n,k):
    if n < 0 or k < 0 or k > n: return 0
    if 2*k > n: k = n-k
    answer = 1
    for i in range(k):
        answer = (answer * (n-i)) // (i+1)
        if answer > MAX:
            return MAX+1
    return answer

if choose(M,rozdaj) < K:
    print('impossible')
    import sys
    sys.exit()

for add in range(M):
    # checking whether to add an extra number (M-add)
    if choose(M-add-1,rozdaj) < K:
        pocet[add] += 1
        K -= choose(M-add-1,rozdaj)
        rozdaj -= 1

for add in range(M):
    for i in range(pocet[add]):
        print(M-add)

